﻿using Arawn.Modules.Cryptography;
using System.Linq;
using Arawn.Modules.Storage;
using Arawn.Modules.Storage.Models;
using System;
using System.Collections.ObjectModel;
using Xamarin.Forms;

namespace Arawn
{
    public partial class MainPage : TabbedPage
    {
        public bool ThemeLoaded { get; set; } = false;
        public BackPageType BackPage { get; set; } = BackPageType.Login;
        public bool IsAccessGranted { get; set; } = !CryptographyHelper.UserNeedPassword();

        public MainPage()
		{
            InitializeComponent();

            //CryptographyHelper.PASSWORD = CryptographyHelper.Encrypt("0000", "0000");

            //StorageHelper.IDENTIFIERS.Add(new Identifier()
            //{
            //    Name = "Facebook",
            //    Description = "Mot de passe pour se connecter au site. Le mot de passe servira pour navigateur lourd ou l'application mobile sans soucis.",
            //    Username = "identifiant",
            //    Password1 = CryptographyHelper.Encrypt("blablaface", CryptographyHelper.PASSWORD)
            //});
            //StorageHelper.IDENTIFIERS.Add(new Identifier()
            //{
            //    Name = "Youtube",
            //    Description = "Se connecter au site",
            //    Username = "identifiant",
            //    Password1 = CryptographyHelper.Encrypt("blablayou", CryptographyHelper.PASSWORD),
            //    ImagePath = "youtb.png"
            //});
            //StorageHelper.CATEGORIES.Add(new Category()
            //{
            //    Name = "Sites",
            //    Identifiers = new ObservableCollection<Identifier>() { StorageHelper.IDENTIFIERS[0], StorageHelper.IDENTIFIERS[1] }
            //});
            //StorageHelper.CATEGORIES.Add(new Category()
            //{
            //    Name = "Autres",
            //    Identifiers = new ObservableCollection<Identifier>() { StorageHelper.IDENTIFIERS[0] }
            //});
            //StorageHelper.CATEGORIES.Add(new Category()
            //{
            //    Name = "Encore"
            //});

            //StorageHelper.THEME = "Light";

            //StorageHelper.SaveTheme();
            //StorageHelper.SaveDatas();
        }

        private void TabbedPage_Appearing(object sender, EventArgs e)
        {
            if (!this.ThemeLoaded)
            {
                StorageHelper.LoadTheme();
                this.ThemeLoaded = true;
            }

            if (!this.IsAccessGranted)
                CryptographyHelper.DisplayAskPassword(this, AskPasswordPageType.Login);
            else if (this.BackPage == BackPageType.Login)
            {
                StorageHelper.LoadDatas();
                this.CategoriesListPage.LoadDatas();
                this.IdentifiersListPage.LoadDatas();
            }
        }
    }

    public enum BackPageType
    {
        None,
        Login,
        Deleted,
        OpenEditor
    }
}
