﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;

namespace Arawn.Modules.Storage.Models
{
    public class Identifier : INotifyPropertyChanged
    {
        public int Id { get; set; }

        private string name;
        public string Name
        {
            get { return name; }
            set { name = value;
                OnPropertyChanged("Name");
            }
        }

        private string imagePath;
        public string ImagePath
        {
            get { return imagePath; }
            set { imagePath = value;
                OnPropertyChanged("ImagePath");
            }
        }

        private string username;
        public string Username
        {
            get { return username; }
            set { username = value;
                OnPropertyChanged("Username");
            }
        }

        private string password1;
        public string Password1
        {
            get { return password1; }
            set { password1 = value;
                OnPropertyChanged("Password1");
            }
        }

        private string password2;
        public string Password2
        {
            get { return password2; }
            set { password2 = value;
                OnPropertyChanged("Password2");
            }
        }

        private string password3;
        public string Password3
        {
            get { return password3; }
            set { password3 = value;
                OnPropertyChanged("Password3");
            }
        }

        private string description;
        public string Description
        {
            get { return description; }
            set { description = value;
                OnPropertyChanged("Description");
            }
        }
        
        public Identifier()
        {
            this.Id = StorageHelper.IDENTIFIERS.Count > 0 ? StorageHelper.IDENTIFIERS.Max(x => x.Id) + 1 : 1;
            this.Name = "Nouvel Identifiant";
            this.ImagePath = "";
            this.Username = "";
            this.Password1 = "";
            this.Password2 = "";
            this.Password3 = "";
            this.Description = "";
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}
