﻿using Arawn.Modules.Cryptography.Pages;
using Arawn.Modules.Storage.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using System.Globalization;
using Arawn.Modules.Storage;

namespace Arawn.Pages.Categories
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class CategoriesListPage : ContentPage
	{
		public CategoriesListPage ()
		{
			InitializeComponent();
		}

        public void LoadDatas()
        {
            this.CategoriesListView.ItemsSource = StorageHelper.CATEGORIES;
        }

        private async void TextCell_Tapped(object sender, EventArgs e)
        {
            CategoryViewer cateviewer = new CategoryViewer((Category)this.CategoriesListView.SelectedItem);
            await this.Navigation.PushModalAsync(cateviewer, false);

            this.CategoriesListView.SelectedItem = null;
        }

        private async void Add_Clicked(object sender, EventArgs e)
        {
            Category category = new Category();
            StorageHelper.CATEGORIES.Add(category);
            StorageHelper.SaveDatas();

            CategoryViewer cateviewer = new CategoryViewer(category);
            cateviewer.BackTypeEditor = BackPageType.OpenEditor;
            await this.Navigation.PushModalAsync(cateviewer, false);
        }
    }

    public class CategoryToCountConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            int count = ((ObservableCollection<Identifier>)value).Count;
            return $"\t({count} élément{(count > 1 ? "s" : "")})";
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}