﻿using Arawn.Modules.Storage;
using Arawn.Modules.Storage.Models;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Arawn.Pages.Categories
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class CategoryEditor : ContentPage
	{
        public Category Category { get; set; }
        public CategoryViewer CategoryViewer { get; set; }

        public static Category CURRENTCATEGORY;

        public CategoryEditor (CategoryViewer cateviewer, Category category)
		{
            CURRENTCATEGORY = category;

            this.CategoryViewer = cateviewer;
            this.Category = category;

            this.BindingContext = this.Category;

			InitializeComponent ();

            this.ListviewIdentifiers.ItemsSource = StorageHelper.IDENTIFIERS;
		}

        protected override bool OnBackButtonPressed()
        {
            StorageHelper.SaveDatas();
            return base.OnBackButtonPressed();
        }

        private async void Delete_Tapped(object sender, EventArgs e)
        {
            if (await this.DisplayAlert("Confirmation", "Voulez-vous vraiment supprimer cette catégorie ?", "Oui", "Non"))
            {
                StorageHelper.CATEGORIES.Remove(this.Category);

                StorageHelper.SaveDatas();
                this.CategoryViewer.BackTypeEditor = BackPageType.Deleted;

                this.OnBackButtonPressed();
            }
        }

        private void SwitchCell_OnChanged(object sender, ToggledEventArgs e)
        {
            Identifier identifier = (Identifier)((SwitchCell)sender).BindingContext;

            if (!((SwitchCell)sender).On && this.Category.Identifiers.Contains(identifier))
                this.Category.Identifiers.Remove(identifier);
            else if (((SwitchCell)sender).On && !this.Category.Identifiers.Contains(identifier))
                this.Category.Identifiers.Add(identifier);
        }

        private void ListviewIdentifiers_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            if (((ListView)sender).SelectedItem != null)
                ((ListView)sender).SelectedItem = null;
        }
    }

    public class IdentifierToSwitchCellValue : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return CategoryEditor.CURRENTCATEGORY.Identifiers.Contains((Identifier)value);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return null;
        }
    }
}