﻿using Arawn.Modules.Storage.Models;
using Arawn.Pages.Identifiers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Arawn.Pages.Categories
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class CategoryViewer : ContentPage
	{
        public Category Category { get; set; }

        public BackPageType BackTypeEditor { get; set; } = BackPageType.None;

        public CategoryViewer (Category category)
		{
            this.Category = category;
            this.BindingContext = this.Category;

			InitializeComponent();
            this.IdentifiersListView.ItemsSource = this.Category.Identifiers;
        }

        private async void TextCell_Tapped(object sender, EventArgs e)
        {
            IdentifierViewer idenviewer = new IdentifierViewer((Identifier)this.IdentifiersListView.SelectedItem);
            await this.Navigation.PushModalAsync(idenviewer, false);

            this.IdentifiersListView.SelectedItem = null;
        }

        private async void EditTapped(object sender, EventArgs e)
        {
            CategoryEditor editor = new CategoryEditor(this, this.Category);
            await this.Navigation.PushModalAsync(editor, false);
        }

        private void ContentPage_Appearing(object sender, EventArgs e)
        {
            if (this.BackTypeEditor == BackPageType.OpenEditor)
            {
                this.BackTypeEditor = BackPageType.None;
                this.EditTapped(sender, e);
            }
            if (this.BackTypeEditor == BackPageType.Deleted)
                this.OnBackButtonPressed();
        }
    }
}