﻿using Arawn.Modules.Storage.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using System.Globalization;
using Arawn.Modules.Cryptography;
using System.Collections.ObjectModel;
using Arawn.Modules.Storage;

namespace Arawn.Pages.Identifiers
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class IdentifierViewer : ContentPage, INotifyPropertyChanged
    {
        public Identifier Identifier { get; set; }
        public BackPageType BackTypeEditor { get; set; } = BackPageType.None;

        public IdentifierViewer(Identifier iden)
        {
            this.Identifier = iden;
            this.BindingContext = this.Identifier;

            InitializeComponent();
        }

        private void OnTapGestureRecognizerTapped(object sender, EventArgs e)
        {
            if ((Label)sender == this.Label_password1)
                if (((Label)sender).Text.Equals(CryptographyHelper.Decrypt(this.Identifier.Password1, CryptographyHelper.PASSWORD)))
                    this.Label_password1.Text = "* * * * *";
                else
                    this.Label_password1.Text = CryptographyHelper.Decrypt(this.Identifier.Password1, CryptographyHelper.PASSWORD);
            else if ((Label)sender == this.Label_password2)
                if (((Label)sender).Text.Equals(CryptographyHelper.Decrypt(this.Identifier.Password2, CryptographyHelper.PASSWORD)))
                    this.Label_password2.Text = "* * * * *";
                else
                    this.Label_password2.Text = CryptographyHelper.Decrypt(this.Identifier.Password2, CryptographyHelper.PASSWORD);
            else if ((Label)sender == this.Label_password3)
                if (((Label)sender).Text.Equals(CryptographyHelper.Decrypt(this.Identifier.Password3, CryptographyHelper.PASSWORD)))
                    this.Label_password3.Text = "* * * * *";
                else
                    this.Label_password3.Text = CryptographyHelper.Decrypt(this.Identifier.Password3, CryptographyHelper.PASSWORD);
        }

        private async void EditTapped(object sender, EventArgs e)
        {
            IdentifierEditor ideneditor = new IdentifierEditor(this, this.Identifier);
            await this.Navigation.PushModalAsync(ideneditor, false);
        }

        private void ContentPage_Appearing(object sender, EventArgs e)
        {
            this.ListviewCategories.ItemsSource = StorageHelper.CATEGORIES.Where(x => x.Identifiers.Contains(this.Identifier));

            if (this.BackTypeEditor == BackPageType.OpenEditor)
            {
                this.BackTypeEditor = BackPageType.None;
                this.EditTapped(sender, e);
            }
            if (this.BackTypeEditor == BackPageType.Deleted)
                this.OnBackButtonPressed();
        }

        private void ListviewCategories_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            if (((ListView)sender).SelectedItem != null)
                ((ListView)sender).SelectedItem = null;
        }
    }

    public class StringIsNullOrEmptyToVisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return !String.IsNullOrEmpty(value.ToString());
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}