﻿using Arawn.Modules.Storage;
using Arawn.Modules.Storage.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Arawn.Pages.Identifiers
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class IdentifiersListPage : ContentPage
	{
        public IdentifiersListPage()
		{
            InitializeComponent();
		}
        
        public void LoadDatas()
        {
            this.IdentifiersListView.ItemsSource = StorageHelper.IDENTIFIERS;
        }

        private async void TextCell_Tapped(object sender, EventArgs e)
        {
            IdentifierViewer idenviewer = new IdentifierViewer((Identifier)this.IdentifiersListView.SelectedItem);
            await this.Navigation.PushModalAsync(idenviewer, false);

            this.IdentifiersListView.SelectedItem = null;
        }

        private async void Add_Clicked(object sender, EventArgs e)
        {
            Identifier identifier = new Identifier();
            StorageHelper.IDENTIFIERS.Add(identifier);
            StorageHelper.SaveDatas();

            IdentifierViewer idenviewer = new IdentifierViewer(identifier);
            idenviewer.BackTypeEditor = BackPageType.OpenEditor;
            await this.Navigation.PushModalAsync(idenviewer, false);
        }
    }
}